C---------------------------------------------------------------------- DAS00010
      DOUBLE PRECISION FUNCTION DASUM(N,DX,INCX)                        DAS00020
C                                                                       DAS00030
C     TAKES THE SUM OF THE ABSOLUTE VALUES.                             DAS00040
C     JACK DONGARRA, LINPACK, 3/11/78.                                  DAS00050
C---------------------------------------------------------------------- DAS00060
      DOUBLE PRECISION DX(N),DTEMP                                      DAS00070
      INTEGER I,INCX,M,MP1,N,NINCX                                      DAS00080
C                                                                       DAS00090
      DASUM = 0.0D0                                                     DAS00100
      DTEMP = 0.0D0                                                     DAS00110
      IF(N.LE.0)RETURN                                                  DAS00120
      IF(INCX.EQ.1)GO TO 20                                             DAS00130
C                                                                       DAS00140
C        CODE FOR INCREMENT NOT EQUAL TO 1                              DAS00150
C                                                                       DAS00160
      NINCX = N*INCX                                                    DAS00170
      DO 10 I = 1,NINCX,INCX                                            DAS00180
        DTEMP = DTEMP + DABS(DX(I))                                     DAS00190
   10 CONTINUE                                                          DAS00200
      DASUM = DTEMP                                                     DAS00210
      RETURN                                                            DAS00220
C                                                                       DAS00230
C        CODE FOR INCREMENT EQUAL TO 1                                  DAS00240
C                                                                       DAS00250
C                                                                       DAS00260
C        CLEAN-UP LOOP                                                  DAS00270
C                                                                       DAS00280
   20 M = MOD(N,6)                                                      DAS00290
      IF( M .EQ. 0 ) GO TO 40                                           DAS00300
      DO 30 I = 1,M                                                     DAS00310
        DTEMP = DTEMP + DABS(DX(I))                                     DAS00320
   30 CONTINUE                                                          DAS00330
      IF( N .LT. 6 ) GO TO 60                                           DAS00340
   40 MP1 = M + 1                                                       DAS00350
      DO 50 I = MP1,N,6                                                 DAS00360
        DTEMP = DTEMP + DABS(DX(I)) + DABS(DX(I + 1)) + DABS(DX(I + 2)) DAS00370
     *  + DABS(DX(I + 3)) + DABS(DX(I + 4)) + DABS(DX(I + 5))           DAS00380
   50 CONTINUE                                                          DAS00390
   60 DASUM = DTEMP                                                     DAS00400
      RETURN                                                            DAS00410
      END                                                               DAS00420

C---------------------------------------------------------------------- DDO00010
      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)                 DDO00020
C                                                                       DDO00030
C     FORMS THE DOT PRODUCT OF TWO VECTORS.                             DDO00040
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  DDO00050
C     JACK DONGARRA, LINPACK, 3/11/78.                                  DDO00060
C---------------------------------------------------------------------- DDO00070
      DOUBLE PRECISION DX(N),DY(N),DTEMP                                DDO00080
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 DDO00090
C                                                                       DDO00100
      DDOT = 0.0D0                                                      DDO00110
      DTEMP = 0.0D0                                                     DDO00120
      IF(N.LE.0)RETURN                                                  DDO00130
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               DDO00140
C                                                                       DDO00150
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                DDO00160
C          NOT EQUAL TO 1                                               DDO00170
C                                                                       DDO00180
      IX = 1                                                            DDO00190
      IY = 1                                                            DDO00200
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 DDO00210
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 DDO00220
      DO 10 I = 1,N                                                     DDO00230
        DTEMP = DTEMP + DX(IX)*DY(IY)                                   DDO00240
        IX = IX + INCX                                                  DDO00250
        IY = IY + INCY                                                  DDO00260
   10 CONTINUE                                                          DDO00270
      DDOT = DTEMP                                                      DDO00280
      RETURN                                                            DDO00290
C                                                                       DDO00300
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            DDO00310
C                                                                       DDO00320
C                                                                       DDO00330
C        CLEAN-UP LOOP                                                  DDO00340
C                                                                       DDO00350
   20 M = MOD(N,5)                                                      DDO00360
      IF( M .EQ. 0 ) GO TO 40                                           DDO00370
      DO 30 I = 1,M                                                     DDO00380
        DTEMP = DTEMP + DX(I)*DY(I)                                     DDO00390
   30 CONTINUE                                                          DDO00400
      IF( N .LT. 5 ) GO TO 60                                           DDO00410
   40 MP1 = M + 1                                                       DDO00420
      DO 50 I = MP1,N,5                                                 DDO00430
        DTEMP = DTEMP + DX(I)*DY(I) + DX(I + 1)*DY(I + 1) +             DDO00440
     *   DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) + DX(I + 4)*DY(I + 4)DDO00450
   50 CONTINUE                                                          DDO00460
   60 DDOT = DTEMP                                                      DDO00470
      RETURN                                                            DDO00480
      END                                                               DDO00490

C---------------------------------------------------------------------- DAX00010
      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)                            DAX00020
C                                                                       DAX00030
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.                            DAX00040
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  DAX00050
C     JACK DONGARRA, LINPACK, 3/11/78.                                  DAX00060
C---------------------------------------------------------------------- DAX00070
      DOUBLE PRECISION DX(N),DY(N),DA                                   DAX00080
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 DAX00090
C                                                                       DAX00100
      IF(N.LE.0)RETURN                                                  DAX00110
      IF (DA .EQ. 0.0D0) RETURN                                         DAX00120
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               DAX00130
C                                                                       DAX00140
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                DAX00150
C          NOT EQUAL TO 1                                               DAX00160
C                                                                       DAX00170
      IX = 1                                                            DAX00180
      IY = 1                                                            DAX00190
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 DAX00200
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 DAX00210
      DO 10 I = 1,N                                                     DAX00220
        DY(IY) = DY(IY) + DA*DX(IX)                                     DAX00230
        IX = IX + INCX                                                  DAX00240
        IY = IY + INCY                                                  DAX00250
   10 CONTINUE                                                          DAX00260
      RETURN                                                            DAX00270
C                                                                       DAX00280
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            DAX00290
C                                                                       DAX00300
C                                                                       DAX00310
C        CLEAN-UP LOOP                                                  DAX00320
C                                                                       DAX00330
   20 M = MOD(N,4)                                                      DAX00340
      IF( M .EQ. 0 ) GO TO 40                                           DAX00350
      DO 30 I = 1,M                                                     DAX00360
        DY(I) = DY(I) + DA*DX(I)                                        DAX00370
   30 CONTINUE                                                          DAX00380
      IF( N .LT. 4 ) RETURN                                             DAX00390
   40 MP1 = M + 1                                                       DAX00400
      DO 50 I = MP1,N,4                                                 DAX00410
        DY(I) = DY(I) + DA*DX(I)                                        DAX00420
        DY(I + 1) = DY(I + 1) + DA*DX(I + 1)                            DAX00430
        DY(I + 2) = DY(I + 2) + DA*DX(I + 2)                            DAX00440
        DY(I + 3) = DY(I + 3) + DA*DX(I + 3)                            DAX00450
   50 CONTINUE                                                          DAX00460
      RETURN                                                            DAX00470
      END                                                               DAX00480

C---------------------------------------------------------------------- DSC00010
      SUBROUTINE  DSCAL(N,DA,DX,INCX)                                   DSC00020
C                                                                       DSC00030
C     SCALES A VECTOR BY A CONSTANT.                                    DSC00040
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.                   DSC00050
C     JACK DONGARRA, LINPACK, 3/11/78.                                  DSC00060
C---------------------------------------------------------------------- DSC00070
      DOUBLE PRECISION DA,DX(N)                                         DSC00080
      INTEGER I,INCX,M,MP1,N,NINCX                                      DSC00090
C                                                                       DSC00100
      IF(N.LE.0)RETURN                                                  DSC00110
      IF(INCX.EQ.1)GO TO 20                                             DSC00120
C                                                                       DSC00130
C        CODE FOR INCREMENT NOT EQUAL TO 1                              DSC00140
C                                                                       DSC00150
      NINCX = N*INCX                                                    DSC00160
      DO 10 I = 1,NINCX,INCX                                            DSC00170
        DX(I) = DA*DX(I)                                                DSC00180
   10 CONTINUE                                                          DSC00190
      RETURN                                                            DSC00200
C                                                                       DSC00210
C        CODE FOR INCREMENT EQUAL TO 1                                  DSC00220
C                                                                       DSC00230
C                                                                       DSC00240
C        CLEAN-UP LOOP                                                  DSC00250
C                                                                       DSC00260
   20 M = MOD(N,5)                                                      DSC00270
      IF( M .EQ. 0 ) GO TO 40                                           DSC00280
      DO 30 I = 1,M                                                     DSC00290
        DX(I) = DA*DX(I)                                                DSC00300
   30 CONTINUE                                                          DSC00310
      IF( N .LT. 5 ) RETURN                                             DSC00320
   40 MP1 = M + 1                                                       DSC00330
      DO 50 I = MP1,N,5                                                 DSC00340
        DX(I) = DA*DX(I)                                                DSC00350
        DX(I + 1) = DA*DX(I + 1)                                        DSC00360
        DX(I + 2) = DA*DX(I + 2)                                        DSC00370
        DX(I + 3) = DA*DX(I + 3)                                        DSC00380
        DX(I + 4) = DA*DX(I + 4)                                        DSC00390
   50 CONTINUE                                                          DSC00400
      RETURN                                                            DSC00410
      END                                                               DSC00420

C---------------------------------------------------------------------- DSW00010
      SUBROUTINE  DSWAP (N,DX,INCX,DY,INCY)                             DSW00020
C                                                                       DSW00030
C     INTERCHANGES TWO VECTORS.                                         DSW00040
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL ONE.                     DSW00050
C     JACK DONGARRA, LINPACK, 3/11/78.                                  DSW00060
C---------------------------------------------------------------------- DSW00070
      DOUBLE PRECISION DX(N),DY(N),DTEMP                                DSW00080
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 DSW00090
C                                                                       DSW00100
      IF(N.LE.0)RETURN                                                  DSW00110
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               DSW00120
C                                                                       DSW00130
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL       DSW00140
C         TO 1                                                          DSW00150
C                                                                       DSW00160
      IX = 1                                                            DSW00170
      IY = 1                                                            DSW00180
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 DSW00190
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 DSW00200
      DO 10 I = 1,N                                                     DSW00210
        DTEMP = DX(IX)                                                  DSW00220
        DX(IX) = DY(IY)                                                 DSW00230
        DY(IY) = DTEMP                                                  DSW00240
        IX = IX + INCX                                                  DSW00250
        IY = IY + INCY                                                  DSW00260
   10 CONTINUE                                                          DSW00270
      RETURN                                                            DSW00280
C                                                                       DSW00290
C       CODE FOR BOTH INCREMENTS EQUAL TO 1                             DSW00300
C                                                                       DSW00310
C                                                                       DSW00320
C       CLEAN-UP LOOP                                                   DSW00330
C                                                                       DSW00340
   20 M = MOD(N,3)                                                      DSW00350
      IF( M .EQ. 0 ) GO TO 40                                           DSW00360
      DO 30 I = 1,M                                                     DSW00370
        DTEMP = DX(I)                                                   DSW00380
        DX(I) = DY(I)                                                   DSW00390
        DY(I) = DTEMP                                                   DSW00400
   30 CONTINUE                                                          DSW00410
      IF( N .LT. 3 ) RETURN                                             DSW00420
   40 MP1 = M + 1                                                       DSW00430
      DO 50 I = MP1,N,3                                                 DSW00440
        DTEMP = DX(I)                                                   DSW00450
        DX(I) = DY(I)                                                   DSW00460
        DY(I) = DTEMP                                                   DSW00470
        DTEMP = DX(I + 1)                                               DSW00480
        DX(I + 1) = DY(I + 1)                                           DSW00490
        DY(I + 1) = DTEMP                                               DSW00500
        DTEMP = DX(I + 2)                                               DSW00510
        DX(I + 2) = DY(I + 2)                                           DSW00520
        DY(I + 2) = DTEMP                                               DSW00530
   50 CONTINUE                                                          DSW00540
      RETURN                                                            DSW00550
      END                                                               DSW00560

C---------------------------------------------------------------------- IDA00010
      INTEGER FUNCTION IDAMAX(N,DX,INCX)                                IDA00020
C                                                                       IDA00030
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.            IDA00040
C     JACK DONGARRA, LINPACK, 3/11/78.                                  IDA00050
C---------------------------------------------------------------------- IDA00060
      DOUBLE PRECISION DX(N),DMAX                                       IDA00070
      INTEGER I,INCX,IX,N                                               IDA00080
C                                                                       IDA00090
      IDAMAX = 0                                                        IDA00100
      IF( N .LT. 1 ) RETURN                                             IDA00110
      IDAMAX = 1                                                        IDA00120
      IF(N.EQ.1)RETURN                                                  IDA00130
      IF(INCX.EQ.1)GO TO 20                                             IDA00140
C                                                                       IDA00150
C        CODE FOR INCREMENT NOT EQUAL TO 1                              IDA00160
C                                                                       IDA00170
      IX = 1                                                            IDA00180
      DMAX = DABS(DX(1))                                                IDA00190
      IX = IX + INCX                                                    IDA00200
      DO 10 I = 2,N                                                     IDA00210
         IF(DABS(DX(IX)).LE.DMAX) GO TO 5                               IDA00220
         IDAMAX = I                                                     IDA00230
         DMAX = DABS(DX(IX))                                            IDA00240
    5    IX = IX + INCX                                                 IDA00250
   10 CONTINUE                                                          IDA00260
      RETURN                                                            IDA00270
C                                                                       IDA00280
C        CODE FOR INCREMENT EQUAL TO 1                                  IDA00290
C                                                                       IDA00300
   20 DMAX = DABS(DX(1))                                                IDA00310
      DO 30 I = 2,N                                                     IDA00320
         IF(DABS(DX(I)).LE.DMAX) GO TO 30                               IDA00330
         IDAMAX = I                                                     IDA00340
         DMAX = DABS(DX(I))                                             IDA00350
   30 CONTINUE                                                          IDA00360
      RETURN                                                            IDA00370
      END                                                               IDA00380

C---------------------------------------------------------------------- DCO00010
      SUBROUTINE  DCOPY(N,DX,INCX,DY,INCY)                              DCO00020
C                                                                       DCO00030
C     COPIES A VECTOR, X, TO A VECTOR, Y.                               DCO00040
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  DCO00050
C     JACK DONGARRA, LINPACK, 3/11/78.                                  DCO00060
C---------------------------------------------------------------------- DCO00070
      DOUBLE PRECISION DX(N),DY(N)                                      DCO00080
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 DCO00090
C                                                                       DCO00100
      IF(N.LE.0)RETURN                                                  DCO00110
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               DCO00120
C                                                                       DCO00130
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                DCO00140
C          NOT EQUAL TO 1                                               DCO00150
C                                                                       DCO00160
      IX = 1                                                            DCO00170
      IY = 1                                                            DCO00180
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 DCO00190
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 DCO00200
      DO 10 I = 1,N                                                     DCO00210
        DY(IY) = DX(IX)                                                 DCO00220
        IX = IX + INCX                                                  DCO00230
        IY = IY + INCY                                                  DCO00240
   10 CONTINUE                                                          DCO00250
      RETURN                                                            DCO00260
C                                                                       DCO00270
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            DCO00280
C                                                                       DCO00290
C                                                                       DCO00300
C        CLEAN-UP LOOP                                                  DCO00310
C                                                                       DCO00320
   20 M = MOD(N,7)                                                      DCO00330
      IF( M .EQ. 0 ) GO TO 40                                           DCO00340
      DO 30 I = 1,M                                                     DCO00350
        DY(I) = DX(I)                                                   DCO00360
   30 CONTINUE                                                          DCO00370
      IF( N .LT. 7 ) RETURN                                             DCO00380
   40 MP1 = M + 1                                                       DCO00390
      DO 50 I = MP1,N,7                                                 DCO00400
        DY(I) = DX(I)                                                   DCO00410
        DY(I + 1) = DX(I + 1)                                           DCO00420
        DY(I + 2) = DX(I + 2)                                           DCO00430
        DY(I + 3) = DX(I + 3)                                           DCO00440
        DY(I + 4) = DX(I + 4)                                           DCO00450
        DY(I + 5) = DX(I + 5)                                           DCO00460
        DY(I + 6) = DX(I + 6)                                           DCO00470
   50 CONTINUE                                                          DCO00480
      RETURN                                                            DCO00490
      END                                                               DCO00500
