	logical function condition(argument,option)

c	Used for convenience in various routines
c	option 0 = False
c	options 1-19 = various conditions
c	options .ge. than 20 = "True every <option> <argument>"
c				(eg every 100 steps)

	integer argument,option

c	condition=.false.
	condition=.true.

	IF ((option.ne.0).and.(option.ge.20)) THEN

	  condition=mod(argument,option).eq.0
	  RETURN

	ELSE

c	  New version of 0-option:

	  if(option.eq.0) then
	    condition=.false.
	    return
	  endif

c	  The next option is for fixbond.F (write bond lengths)

	  if(option.eq.1) then
	    condition=
     &      (argument.gt.2000).and.(argument-1000*(argument/1000).eq.0)
	    return
	  endif

c	  The next option is for minimg.F (any atom outof the box?)

	  if(option.eq.2) then
	    condition=
     &      (argument.lt.1).or.(argument.gt.27)
	    return
	  endif


C	  DEBUGGING ON EGALEO: 191200-1
c	  This is used in formh.F
C	  DEBUGGING ON EGALEO: 211200-4
C	  in penalty.F as well

	  if(option.eq.6) then
	    condition=
     &      ((argument.lt.1000).and.
     &	    (argument-100*(argument/100).eq.0))
     &      .or.(argument-5000*(argument/5000).eq.0)
	    return
	  endif

	  if(option.eq.7) then
	    condition=
     &      argument-10000*(argument/10000).eq.0
	    return
	  endif


	  if(option.eq.8) then
	    condition=
     &      argument-5000*(argument/5000).eq.0
	    return
	  endif

	  if(option.eq.10) then
	    condition=.true. 
	    return
	  endif

	ENDIF

	WRITE(6,*)  
	WRITE(6,*)  'undetermined option in logical function'
	WRITE(6,*)  '           CONDITION.F                 '
	WRITE(6,*)
	WRITE(6,*)  '(argument= ',argument,' option= ',option,')'
	STOP


	END
