c ---- this subroutine initializes variables to zero, and replaces the
c      many data statements present in KFM's code

c +----------------------------------------------------------+
c | called by ppmd1                                          |
c |                                                          |
c | MLG 8/2/93                                               |
c +----------------------------------------------------------+

      subroutine initialize

      implicit none

#include "ppmdparam1.h"
#include "ppmdparam2.h"
#include "ppmdparam3.h"

#include "averages.h"
#include "conv.h"
#include "derivs.h"
#include "doros.h"
#include "forces.h"
#include "index.h"
#include "listr.h"
#include "potprm.h"
#include "scalpos.h"
#include "times.h"
#include "which.h"
#include "deiktes.h"

c > LOCAL variables

      integer ch1, at1, ith, i, j

c ---- matrices (natom by nchain)

      do ch1 = 1, maxchain
        do at1 = 1, maxatmc

c	 xi = i-th derivative of x

          x1mc(at1,ch1) = 0.0d0
          y1mc(at1,ch1) = 0.0d0
          z1mc(at1,ch1) = 0.0d0

          x2mc(at1,ch1) = 0.0d0
          y2mc(at1,ch1) = 0.0d0
          z2mc(at1,ch1) = 0.0d0

          x3mc(at1,ch1) = 0.0d0
          y3mc(at1,ch1) = 0.0d0
          z3mc(at1,ch1) = 0.0d0

          x4mc(at1,ch1) = 0.0d0
          y4mc(at1,ch1) = 0.0d0
          z4mc(at1,ch1) = 0.0d0

          x5mc(at1,ch1) = 0.0d0
          y5mc(at1,ch1) = 0.0d0
          z5mc(at1,ch1) = 0.0d0

          fxmc(at1,ch1) = 0.0d0
          fymc(at1,ch1) = 0.0d0
          fzmc(at1,ch1) = 0.0d0

        enddo

        do at1 = 1, maxatsu

c	 xi = i-th derivative of x

          x1su(at1,ch1) = 0.0d0
          y1su(at1,ch1) = 0.0d0
          z1su(at1,ch1) = 0.0d0

          x2su(at1,ch1) = 0.0d0
          y2su(at1,ch1) = 0.0d0
          z2su(at1,ch1) = 0.0d0

          x3su(at1,ch1) = 0.0d0
          y3su(at1,ch1) = 0.0d0
          z3su(at1,ch1) = 0.0d0

          x4su(at1,ch1) = 0.0d0
          y4su(at1,ch1) = 0.0d0
          z4su(at1,ch1) = 0.0d0

          x5su(at1,ch1) = 0.0d0
          y5su(at1,ch1) = 0.0d0
          z5su(at1,ch1) = 0.0d0

          fxsu(at1,ch1) = 0.0d0
          fysu(at1,ch1) = 0.0d0
          fzsu(at1,ch1) = 0.0d0

        enddo
      enddo

      do ch1 = 1, maxchain
        do at1 = 1, maxatmc

          xstmc(at1,ch1) = 0.0d0
          ystmc(at1,ch1) = 0.0d0
          zstmc(at1,ch1) = 0.0d0

        enddo

        do at1 = 1, maxatsu

          xstsu(at1,ch1) = 0.0d0
          ystsu(at1,ch1) = 0.0d0
          zstsu(at1,ch1) = 0.0d0

        enddo
      enddo


c ----- Ayto tha allaxthei sto montelo ton statheron desmon

c      do ch1 = 1, maxchain
c        do at1 = 1, maxbonds
c          do ith = 1, 10
c            lmat(ith, at1, ch1) = 0.0d0
c          enddo
c        enddo
c      enddo


      do ch1 = 1, 3
        do at1 = 1, 3

          pimat(at1,ch1)  = 0.0d0
          mvirm(at1,ch1)  = 0.0d0
          hd(at1,ch1)     = 0.0d0

c ---- following were not set by data statements in ppmd1.F

          avmstrss(at1,ch1)  = 0.0d0
          avmstrssq(at1,ch1) = 0.0d0

          hst(at1,ch1)      = 0.0d0

          avird(at1,ch1)   = 0.0d0
          avirdsq(at1,ch1) = 0.0d0

        enddo
      enddo 

c ---- initialize vectors
c
c                  H C R
c              H | 1 2 3 |  Polymer only:
c     ngbin3 = C | 2 4 5 |   There are six different types of interactions.
c              R | 3 5 6 |
c
c                  H C R pen
c              H | 1 2 3 7  | Polymer and penetrant:
c     ngbin3 = C | 2 4 5 8  |  There are 10 different types of interactions.
c              R | 3 5 6 9  |
c            pen | 7 8 9 10 |
c
c	May, 6th 2002 - brapt: Polym + alkane type pentrnt and/or CH4
c	Now, there are 21 different interactions
c	
c  	     Si  CH2  R  C4  CH2(a) R(a)
c	Si    1   2   3   7   11    16   
c      CH2    2   4   5   8   12    17
c        R    3   5   6   9   13    18 
c      CH4    7   8   9  10   14    19
c    CH2(a)  11  12  13  14   15    20
c      R(a)  16  17  18  19   20    21

      ngbin3(1,1) =  1
      ngbin3(2,1) =  2
      ngbin3(3,1) =  3
      ngbin3(1,2) =  2
      ngbin3(2,2) =  4
      ngbin3(3,2) =  5
      ngbin3(1,3) =  3
      ngbin3(2,3) =  5
      ngbin3(3,3) =  6
      ngbin3(1,4) =  7
      ngbin3(2,4) =  8
      ngbin3(3,4) =  9
      ngbin3(4,1) =  7
      ngbin3(4,2) =  8
      ngbin3(4,3) =  9
      ngbin3(4,4) = 10
      ngbin3(1,5) = 11
      ngbin3(5,1) = 11
      ngbin3(2,5) = 12
      ngbin3(5,2) = 12
      ngbin3(3,5) = 13
      ngbin3(5,3) = 13
      ngbin3(4,5) = 14
      ngbin3(5,4) = 14
      ngbin3(5,5) = 15
      ngbin3(1,6) = 16
      ngbin3(6,1) = 16
      ngbin3(2,6) = 17
      ngbin3(6,2) = 17
      ngbin3(3,6) = 18
      ngbin3(6,3) = 18
      ngbin3(4,6) = 19
      ngbin3(6,4) = 19
      ngbin3(5,6) = 20
      ngbin3(6,5) = 20
      ngbin3(6,6) = 21

c
cc ---- scalars
c  notes:
c         delta, delsq, delcu, delqu, delqt, odelta, oodelt
c         trajtme, delinit, relerr, pint, pdiff
c                    were not initialized in KFM's code; 
c                    here they are initialized to zero

      avmpint = 0.0d0
      avmpsq  = 0.0d0
      avdens = 0.0d0
      avdnsq = 0.0d0
      avekin = 0.0d0
      avkesq = 0.0d0
      avewk  = 0.0d0
      avwksq = 0.0d0
      avpote = 0.0d0
      avpesq = 0.0d0
      avpenb = 0.0d0
      avpnsq = 0.0d0
      avpebl = 0.0d0
      avplsq = 0.0d0
      avpeba = 0.0d0
      avpasq = 0.0d0
      avpeta = 0.0d0
      avptsq = 0.0d0
      avpefix= 0.0d0
      avpfsq = 0.0d0
      avtote = 0.0d0
      estep  = 0.0d0
      avtesq = 0.0d0
      elapse = 0.0d0

      avpec  = 0.0d0
      avpecsq= 0.0d0
      avpic  = 0.0d0
      avpicsq= 0.0d0
c      avptc  = 0.0d0
c      avptcsq= 0.0d0
      avesp  = 0.0d0
      avspsq = 0.0d0
      avhame = 0.0d0
      avhasq = 0.0d0

      avpd   = 0.0d0
      avpdsq = 0.0d0

c      avird  = 0.0d0
c      avirdsq= 0.0d0

c ---- following weren't set by data statements in ppmd1.F

c      avpf   = 0.0d0
c      avpfsq = 0.0d0

c      pintd  = 0.0d0
c      pdiff  = 0.0d0

c      relerr = 0.0d0
c      rdelta = 1.0d0

       sp0 = 1.0d0
       sp1 = 0.0d0
       sp2 = 0.0d0
       sp3 = 0.0d0
       sp4 = 0.0d0
       sp5 = 0.0d0

       hl0 = 1.0d0
       hl1 = 0.0d0
       hl2 = 0.0d0
       hl3 = 0.0d0
       hl4 = 0.0d0
       hl5 = 0.0d0

      delta   = 0.0d0
      delsq   = 0.0d0
      delcu   = 0.0d0
      delqu   = 0.0d0
      delqt   = 0.0d0
      odelta  = 0.0d0
      oodelt  = 0.0d0
      elapse  = 0.0d0
      trajtme = 0.0d0
      delinit = 0.0d0

      return
      end
