c
       function rranf(iseed)                           
c                                                                       
c  uniform pseudo-random number generator; mixed congruential type;     
c  the function value is a real number from the interval (0,1),         
c  including 0, excluding 1.                                            
c     
      implicit none
c      implicit integer*4 (i-n)

      real*8 rranf
      integer*4 iseed
      integer*4 ia, ib, ibc, ida, isum, iff, ie, ix, iy
      integer*4 ix2, ix1 

      ib=iseed/65536                                                    
      ia=iseed-ib*65536                                                 
      ibc=ib*63253                                                      
      ida=ia*24301                                                      
      isum=ibc-2147483647+ida                                           
      if(isum.le.0) go to 10                                            
      isum=isum-1                                                       
      go to 20                                                          
   10 isum=isum+2147483647                                              
   20 iff=isum/32768                                                    
      ie=isum-iff*32768                                                 
      ix=ie+ia                                                          
      iy=453816691-2283*ia                                              
      ix2=ix/32768                                                      
      ix1=ix-32768*ix2                                                  
      iseed=ix1*65536-2147483647+iy                                     
      if(iseed.le.0) go to 30                                           
      iseed=iseed-1                                                     
      go to 40                                                          
   30 iseed=iseed+2147483647                                            
   40 rranf=iseed*4.65661287307739257812500D-10
c   40 rranf=iseed*4.65661287524579692410575D-10
c  40 rranf=iseed*4.65661287308d-10                                    
      return                                                            
      end                                                               
