c 
      subroutine avecalc
c
c  Calculate info for property averages and standard deviations and
c  the angles between the basis vectors and their statistical info.
c  All averages are weighted by the time step.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none

#include "ppmdparam1.h"

      integer i,j

      real*8 ptot

#include "averages.h"
#include "box.h"
#include "energy.h"
#include "forces.h"
#include "props.h"
#include "scaling.h"
#include "scalpos.h"
#include "steps.h"
#include "times.h"

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      estep=estep+odelta
      nequil=nequil+1
c
c     avtote = average total energy
c     avtesq = average total energy squared
c
      avtote=avtote+totene*odelta
      avtesq=avtesq+totene*totene*odelta
c
c     avhame = average Hamiltonian
c     avhasq = average Hamiltonian squared
c
      avhame=avhame+hamil*odelta
      avhasq=avhasq+hamil*hamil*odelta
c
c     avpote = average potential energy
c     avpesq = average potential energy squared
c     avpec  = average long-range potential energy
c     avpecsq = average long-range potential energy squared
c
      avpote=avpote+potene*odelta
      avpesq=avpesq+potene*potene*odelta
      avpec=avpec+potlrc*odelta
      avpecsq=avpecsq+potlrc*potlrc*odelta
c
c     avpebl = average bond length
c     avplsq = average bond length squared
c
      avpebl=avpebl+epblsum*odelta
      avplsq=avplsq+epblsum*epblsum*odelta
c
c     avpeba = average bond angle energy
c     avpasq = average bond angle energy squared
c
      avpeba=avpeba+epbasum*odelta
      avpasq=avpasq+epbasum*epbasum*odelta
c
c     avpenb = average nonbonded potential energy
c     avpnsq = average nonbonded potential energy squared
c
      avpenb=avpenb+epnbsum*odelta
      avpnsq=avpnsq+epnbsum*epnbsum*odelta
c
c     avpeta = average torsion angle
c     avptsq = average torsion angle squared
c
      avpeta=avpeta+eptasum*odelta
      avptsq=avptsq+eptasum*eptasum*odelta
c
c     avpint  = average internal pressure = -1/3 Trace(stress)
c     avpsq   = average internal pressure squared 
c     avmpint = average molecular pressure = -1/3 Trace(mstress)
c     avmpsq  = average molecular pressure squared 
c     avpic   = average long-range internal pressure
c     avpicsq = average long-range internal pressure squared 
c     avptc   = average total internal pressure
c     avptcsq = average total internal pressure squared 
c     avtramp = average dynamic term of mol.pressure
c     avtramp1 = average of pimat

      avmpint=avmpint+mpint*odelta
      avmpsq=avmpsq+mpint*mpint*odelta
      avpic=avpic+pintlrc*odelta
      avpicsq=avpicsq+pintlrc*pintlrc*odelta
      ptot=pint+pintlrc
      avptc=avptc+ptot*odelta
      avptcsq=avptcsq+ptot*ptot*odelta
      avtramp=avtramp+tramp*odelta
      avtramp1=avtramp1+tramp1*odelta
c
c     avdens = average density
c     avdnsq = average density squared
c
      avdens=avdens+dense*odelta
      avdnsq=avdnsq+dense*dense*odelta
c
c     avekin = average kinetic energy from molecules
c     avkesq = average kinetic energy from molecules squared
c
      avekin=avekin+trans*odelta
      avkesq=avkesq+trans*trans*odelta
c
c     avesp = average Nose s value
c     avspsq = average Nose s value squared
c
      avesp=avesp+spvalue*odelta
      avspsq=avspsq+spvalue*spvalue*odelta
c
c     avewk = average kinetic energy from box
c     avwksq = average kinetic energy from box squared
c
      avewk=avewk+urans*odelta
      avwksq=avwksq+urans*urans*odelta
c
c     avmstrss = average stress (negative should be there)
c     avmstrssq = average stress squared
c
      do 1 i=1,3
          do 2 j=1,3
              avmstrss(i,j)=avmstrss(i,j)-odelta*mvirm(i,j)
              avmstrssq(i,j)=avmstrssq(i,j)+odelta*mvirm(i,j)
     x                      *mvirm(j,i)
 2        continue
 1    continue
c
      return
      end
