
      subroutine bondlen
c
c	modified by brapt - 19/12/00
c
c     Calculate bond length pair potential and force.
c     A quadratic potential in the interatomic distance is used.
c     It only acts between bonded atoms.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
c

#include "ppmdparam1.h"
#include "ppmdparam2.h"
#include "sizes.h"
c     #include "listi.h"
#include "which.h"
#include "scalpos.h"
#include "posit.h"
#include "paramsr.h"
#include "energy.h"
#include "forces.h"
#include "props.h"
#include "box.h"
#include "steps.h"

C	Local Variables

	integer i,j,nc,mi,idatom1,idatom2
	integer nx,ny,nz

	real*8 xij,yij,zij,
     &       pairp,pairf,fpx,
     &	   fpy,fpz,
     &	   r,xx,yy,zz

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c	Executable Lines Start Here:


c
c     | Bond length minimum image (mibl)
c
      do 90 nc=1,nchains
        do 60 i=1,natmc(nc)-1
          xx=x0mc(i,nc)-x0mc(i+1,nc)
          yy=y0mc(i,nc)-y0mc(i+1,nc)
          zz=z0mc(i,nc)-z0mc(i+1,nc)
          nx=xx+xx
          ny=yy+yy
          nz=zz+zz

c     Calculate bond energy and force

          mi=9*nx+3*ny+nz+14
          idatom1=identmc(i,nc)
          idatom2=identmc(i+1,nc)
          xij=rxmc(i,nc)-rxmc(i+1,nc)-rxl(mi)
          yij=rymc(i,nc)-rymc(i+1,nc)-ryl(mi)
          zij=rzmc(i,nc)-rzmc(i+1,nc)-rzl(mi)
          r=dsqrt(xij*xij+yij*yij+zij*zij)

c    Calculate potential energy and force due to bond stretching

          pairp=kij(idatom1,idatom2)*
     x          (r-rij0(idatom1,idatom2))**2

          pairf=-2.0d0*kij(idatom1,idatom2)*
     x          (r-rij0(idatom1,idatom2))/r

          epblsum=epblsum+pairp

          virmat(1,1)=virmat(1,1)+xij*xij*pairf
          virmat(1,2)=virmat(1,2)+xij*yij*pairf
          virmat(1,3)=virmat(1,3)+xij*zij*pairf
          virmat(2,2)=virmat(2,2)+yij*yij*pairf
          virmat(2,3)=virmat(2,3)+yij*zij*pairf
          virmat(3,3)=virmat(3,3)+zij*zij*pairf

          fpx=pairf*xij
          fpy=pairf*yij
          fpz=pairf*zij
          fxmc(i,nc)=fxmc(i,nc)+fpx
	    fxmc(i+1,nc)=fxmc(i+1,nc)-fpx
          fymc(i,nc)=fymc(i,nc)+fpy
	    fymc(i+1,nc)=fymc(i+1,nc)-fpy
          fzmc(i,nc)=fzmc(i,nc)+fpz
	    fzmc(i+1,nc)=fzmc(i+1,nc)-fpz

60      continue

	  do 4 i=1,natsu(nc)
	    j=sutmc(i)
          xx=x0su(i,nc)-x0mc(j,nc)
          yy=y0su(i,nc)-y0mc(j,nc)
          zz=z0su(i,nc)-z0mc(j,nc)
          nx=xx+xx
          ny=yy+yy
          nz=zz+zz

c     Calculate bond energy and force

          mi=9*nx+3*ny+nz+14
          idatom1=identsu(i,nc)
          idatom2=identmc(j,nc)
          xij=rxsu(i,nc)-rxmc(j,nc)-rxl(mi)
          yij=rysu(i,nc)-rymc(j,nc)-ryl(mi)
          zij=rzsu(i,nc)-rzmc(j,nc)-rzl(mi)
          r=dsqrt(xij*xij+yij*yij+zij*zij)

c    Calculate potential energy due to bond stretching

          pairp=kij(idatom1,idatom2)*
     x         (r-rij0(idatom1,idatom2))**2

          pairf=-2.0d0*kij(idatom1,idatom2)*
     x          (r-rij0(idatom1,idatom2))/r

          epblsum=epblsum+pairp

          virmat(1,1)=virmat(1,1)+xij*xij*pairf
          virmat(1,2)=virmat(1,2)+xij*yij*pairf
          virmat(1,3)=virmat(1,3)+xij*zij*pairf
          virmat(2,2)=virmat(2,2)+yij*yij*pairf
          virmat(2,3)=virmat(2,3)+yij*zij*pairf
          virmat(3,3)=virmat(3,3)+zij*zij*pairf

          fpx=pairf*xij
          fpy=pairf*yij
          fpz=pairf*zij

          fxsu(i,nc)=fxsu(i,nc)+fpx
	    fxmc(j,nc)=fxmc(j,nc)-fpx
          fysu(i,nc)=fysu(i,nc)+fpy
	    fymc(j,nc)=fymc(j,nc)-fpy
          fzsu(i,nc)=fzsu(i,nc)+fpz
	    fzmc(j,nc)=fzmc(j,nc)-fpz

4       continue
90    continue

      virmat(2,1)=virmat(1,2)
      virmat(3,1)=virmat(1,3)
      virmat(3,2)=virmat(2,3)

      return
      end
