
      subroutine correctr
c
c  Six value, fifth order Gear corrector
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      implicit none

#include "ppmdparam1.h"

      integer i,j

#include "constnts.h"
#include "derivs.h"
#include "forces.h"
#include "scalpos.h"
#include "sizes.h"
#include "switches.h"
#include "which.h"
#include "paramsr.h"
c #include "pentrnt.h"

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Note Gear coefficients are chosen to solve r"=f(r,r')
c          f22 = 1.0d0
c          f#2 values are initialized in ppinit, stored in constnts.h
c
  
      do 1 j=1,nchains
         do  i=1,natmc(j)

            x0mc(i,j)=x0mc(i,j)-fxmc(i,j)*f02
            x1mc(i,j)=x1mc(i,j)-fxmc(i,j)*f12
            x2mc(i,j)=x2mc(i,j)-fxmc(i,j)
            x3mc(i,j)=x3mc(i,j)-fxmc(i,j)*f32
            x4mc(i,j)=x4mc(i,j)-fxmc(i,j)*f42
            x5mc(i,j)=x5mc(i,j)-fxmc(i,j)*f52
c
            y0mc(i,j)=y0mc(i,j)-fymc(i,j)*f02
            y1mc(i,j)=y1mc(i,j)-fymc(i,j)*f12
            y2mc(i,j)=y2mc(i,j)-fymc(i,j)
            y3mc(i,j)=y3mc(i,j)-fymc(i,j)*f32
            y4mc(i,j)=y4mc(i,j)-fymc(i,j)*f42
            y5mc(i,j)=y5mc(i,j)-fymc(i,j)*f52
c
            z0mc(i,j)=z0mc(i,j)-fzmc(i,j)*f02
            z1mc(i,j)=z1mc(i,j)-fzmc(i,j)*f12
            z2mc(i,j)=z2mc(i,j)-fzmc(i,j)
            z3mc(i,j)=z3mc(i,j)-fzmc(i,j)*f32
            z4mc(i,j)=z4mc(i,j)-fzmc(i,j)*f42
            z5mc(i,j)=z5mc(i,j)-fzmc(i,j)*f52
	   end do

         do  i=1,natsu(j)

            x0su(i,j)=x0su(i,j)-fxsu(i,j)*f02
            x1su(i,j)=x1su(i,j)-fxsu(i,j)*f12
            x2su(i,j)=x2su(i,j)-fxsu(i,j)
            x3su(i,j)=x3su(i,j)-fxsu(i,j)*f32
            x4su(i,j)=x4su(i,j)-fxsu(i,j)*f42
            x5su(i,j)=x5su(i,j)-fxsu(i,j)*f52
c
            y0su(i,j)=y0su(i,j)-fysu(i,j)*f02
            y1su(i,j)=y1su(i,j)-fysu(i,j)*f12
            y2su(i,j)=y2su(i,j)-fysu(i,j)
            y3su(i,j)=y3su(i,j)-fysu(i,j)*f32
            y4su(i,j)=y4su(i,j)-fysu(i,j)*f42
            y5su(i,j)=y5su(i,j)-fysu(i,j)*f52
c
            z0su(i,j)=z0su(i,j)-fzsu(i,j)*f02
            z1su(i,j)=z1su(i,j)-fzsu(i,j)*f12
            z2su(i,j)=z2su(i,j)-fzsu(i,j)
            z3su(i,j)=z3su(i,j)-fzsu(i,j)*f32
            z4su(i,j)=z4su(i,j)-fzsu(i,j)*f42
            z5su(i,j)=z5su(i,j)-fzsu(i,j)*f52
	  end do

    1 continue

c
c     Only carry out wall corrector if walls are flexible.
c
      if(move) then
c
c     Uniform box dilation corrector
c
         if(uniform)then
            hl0=hl0-f02*hldd
            hl1=hl1-f12*hldd
            hl2=hl2-hldd
            hl3=hl3-f32*hldd
            hl4=hl4-f42*hldd
            hl5=hl5-f52*hldd
         endif
      endif
c
c     Only carry out velocity corrector if using Nose thermostat.
c
      if(nose) then
          sp0=sp0-f02*spd
          sp1=sp1-f12*spd
          sp2=sp2-spd
          sp3=sp3-f32*spd
          sp4=sp4-f42*spd
          sp5=sp5-f52*spd
      endif
c       write(*,*) 'hl=', hl0,hl1,hl2,hl3,hl4, hl5   
c        write(*,*)
c       write(*,*)  x1(1,1),x2(1,1),x3(1,1),x4(1,1),x5(1,1)    
c
c

      return
      end
