      subroutine ppmd3
c
c  Continuation of ppmd2
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      implicit none

#include "ppmdparam1.h"
#include "ppmdparam2.h"

c
      integer lnblnk
      integer i,ii,iip1,j,k

      real*4 dummy
      real*8 ddummy
      integer idummy

      real*8 pintspc
      real*8 delsqh,massi,virlrc,rsq,a,b,temp1,temp2,uspl,
     x       rljt,rspnei,rspnei3,ppotj,pfj
      real*8 xi1,yi1,zi1,xi2,yi2,zi2,del2

c--------------------------------------------------------------------


#include "box.h"
#include "constnts.h"
#include "control.h"
#include "conv.h"
#include "derivs.h"
#include "energy.h"
#include "errors.h"
#include "expene.h"
#include "forces.h"
#include "initial.h"
#include "paramsi.h"
#include "paramsr.h"
#include "port1.h"
#include "port2.h"
#include "potprm.h"
#include "props.h"
#include "scaling.h"
#include "scalpos.h"
#include "sizes.h"
#include "steps.h"
#include "strings.h"
#include "switches.h"
#include "tables.h"
#include "times.h"
#include "which.h"

c new ones added by S&C 12-1-95
#include "averages.h"
#include "box2.h"

c #include "pentrnt.h"
c #include "pen_old.h"

	logical condition

c--------------------------------------------------------------------
c
      delsqh=odelta*odelta*0.5d0
	hamil=0.0d0
c
c    
c     Let's calculate some properties!
c     nstep = # of times properties were calculated
c     dense = density
c     eppsum = potential energy due to molecules
c     enesp = potential and kinetic energy due to temp fluctuations
c            [See: W. G. Hoover, Phys.Rev.A, 31(3), 1695, 1985]
c            [kinetic E = sp1*sp1*spmas/(2.0d0*sp0*sp0*odelta*odelta)]
c            [potential = ndof*tstar*log(sp0)]
c     spvalue = Nose s value
c
c      write(10,460)
  460 format(2x,'Calculate properties')
      elapse=elapse+odelta
      nstep=nstep+1
      dense=(totmass*masscl)/(volscl*vol)

      spvalue=sp0
c
c     hamil = Hamiltonian
c     potene = molecule potential energy
c     potlrc = long-range molecule potential energy
c     trans = kinetic energy due to particle translation
c     urans = kinetic energy due to wall fluctuations (if constant P)
c     elasen = potential energy from Pext*V
c     totene = total energy
c     pintlrc = long-range pressure (long-range Virial/volume)
c
      eppsum=epnbsum+epblsum+epbasum+eptasum +epfixsum + eppensum

      potene=eppsum+elasen
c	if(condition(nstep,0)) then
	if (mod(nstep,100).eq.0) then
	  write(6,*)
	  write(6,*) 'nstep=',nstep
	  write(6,*) 'nonbond:  ',epnbsum
	  write(6,*) 'bondlen:  ',epblsum
	  write(6,*) 'bondang:  ',epbasum
	  write(6,*) 'torsion:  ',eptasum
	  write(6,*) 'pot ene:  ',potene
	  write(6,*) 'Kinetic:  ',trans
        write(6,*) 'Mol pot ene:      ',eppsum
	  write(6,*) 'pot ene from P:   ',elasen
	  write(6,*) 'Kinetic from P:   ',urans
	  write(6,*) 'Pot+Kin from T:   ',enesp
	  write(6,*) 'Long-range corr:  ',potlrc
	endif
c
c     This Hamiltonian contribution is from a real formulation of the
c     equations of motion. See eq. 2.23 from Nose, J.Chem.Phys. 1984, 
c     81, 511. This is why (ndof) is used and not (ndof+1), and s*s 
c     appears in the denominator. [ps' = s.'*Q/(s'*s') from eq 2.21]
c
      if(nose) then
            enesp=sp1*sp1*spmas/(2.0d0*sp0*sp0*odelta*odelta)+
     x            ndof*tstar*log(sp0)
         else
            enesp=0.0d0
      endif

      potlrc=0.0d0
      potspc=0.0d0
      virlrc=0.0d0
      virspc=0.0d0
c
c     This could be optimized but you don't spend any CPU here
c
      if(tails) then
         do 480 j=1,6
            do 480 i=1,6
               k=ngbin3(i,j)
c
c       NEW VERSION (see ppinit.F) :
c
               potlrc=potlrc+ncomp(i)/vol*ncomp(j)*
     x                peconv(k,1)*sigconv(k,1)**3
               potspc=potspc+ncomp(i)/vol*ncomp(j)*
     x                splconv(k)
               virlrc=virlrc+ncomp(i)/vol*ncomp(j)*
     x                peconv(k,1)*sigconv(k,1)**3
c
c              explicit calculation
c
	       if(spline) then
                 rsq=rspne**2
	         call exppot(rsq,ppotj,pfj)
	         uspl=ppotj*peconv(k,1)
c
c       NEW VERSION (see ppinit.F) :
c
	         virspc=virspc+ncomp(i)/vol*ncomp(j)*
     x                ((rspne*sigconv(k,1))**3*uspl
     x                +3.0d0*splconv(k))
	       endif

  480    continue

         if(spline) then
               rljt=rspne
            else
               rljt=rnge(1,1,1)
         endif

         rspnei=1.0d0/rljt
         rspnei3=rspnei*rspnei*rspnei
         potlrc=potlrc*8.0d0*pi/3.0d0*rspnei3*
     x          (rspnei3*rspnei3/3.0d0-1.0d0)
         potspc=potspc*2.0d0*pi
         virlrc=virlrc*16.0d0*pi/3.0d0*rspnei3*
     x          (2.0d0*rspnei3*rspnei3/3.0d0-1.0d0)
         virspc=virspc*2.0d0*pi/3.0d0
      endif

      potlrc=(potlrc-potspc)
      pintlrc=virlrc/vol
      pintspc=virspc/vol
      pintlrc=pintlrc-pintspc

c
      totene=potene+trans+urans+enesp
      hamil=totene+potlrc
c
c     NOTE: (PV)tails = (U)tails ,this can be easily proved when using
c           the spline.
C
c
c     Calculate averages if equilibrated
c
      if(equil) call avecalc
c
c     Thermostat control
c
c     If tvscal > 0, thermostat the system until elapse >= tvscal.
c     Then turn off control. Alternate every tvscaloff and tvscalon 
c     steps between thermostating and not thermostating.  
c     If tvscaloff=0 then thermostat continuously until tvscal reached.
c
c     If not using the Nose thermostat, control the temperature by 
c     re-scaling the velocities of the particles and walls.  This is
c     the brute force approach, but if you make tvscal big enough, 
c     It'll usually work. Only re-scale wall velocities if no wall
c     damping was requested or damping has not yet been started.
c
c     Velocity re-scaling does not give a canonical ensemble and can
c     not be used if the variable time step integrator is being used.
c
c     If the variable timestep integrator is in effect and temperature
c     control is being accomplished via the Nose thermostat, turn off 
c     error checking for a bit to allow the predictor to stabilize.
c     Reduce the time step to the initial time step to minimize
c     truncation error during this time.
c
c     tvscal = time velocity scaling is turned off
c     if errtol>0 then variable step integrator is in use (see ppmd1)

      if(elapse.lt.tvscal) then
        if(scaling)then
          if(tvscaloff.ne.0.)then
            if(elapse.ge.tscal4)then
c                                  |__ turn off scaling for now
              scaling=.false.
              write(10,53)elapse*pstimscl
              tscal3=elapse+tvscaloff
              if(errtol.gt.0.0d0)then
                rdelta=delinit/odelta
                nerror=nstep+10
                nerrck=nerror
              endif
            else
c              |__ set the current velocity scaling factor
              if(.not.nose)then
                if(trans.ne.0.0d0)heatp=sqrt(tmid/trans)
                if((tdampend.eq.0.or.(tdampend.ne.0.and.
     x               elapse.lt.tdampstrt)).and.
     x               urans.ne.0.0d0)heatw=sqrt(umid/urans)
              endif
            endif
          else
            if(.not.nose)then
c                            |__ set the current velocity scaling factor
              if(trans.ne.0.0d0)heatp=sqrt(tmid/trans)
              if((tdampend.eq.0.or.(tdampend.ne.0.and.
     x             elapse.lt.tdampstrt)).and.urans.ne.0.0d0)
     x             heatw=sqrt(umid/urans)
            endif
          endif

        else
c          |__ not scaling, but t < t_vscal_off

          if(elapse.ge.tscal3)then
c                                 |__ turn on scaling for now
            scaling=.true.
            write(10,30)elapse*pstimscl
            tscal4=elapse+tvscalon
            if(errtol.gt.0.0d0)then
              rdelta=delinit/odelta
              nerror=nstep+10
              nerrck=nerror
            endif
          endif
        endif
      else if(scaling.and.elapse.ge.tvscal) then
c                                              |__ turn off scaling for good
        scaling=.false.
        write(10,53)elapse*pstimscl
        if(errtol.gt.0.0d0)then
          rdelta=delinit/odelta
          nerror=nstep+10
          nerrck=nerror
        endif
      endif
 30   format(2x,'Temperature rescaling started at time ',f9.4)
 53   format(2x,'Temperature rescaling terminated at time ',f9.4)
c
c     And now actually rescale velocities.
c
      if(scaling.and..not.nose) then
          do 510 j=1,nchains
             do i=1,natmc(j)
                x1mc(i,j)=x1mc(i,j)*heatp
                y1mc(i,j)=y1mc(i,j)*heatp
                z1mc(i,j)=z1mc(i,j)*heatp
	      end do
             do i=1,natsu(j)
                x1su(i,j)=x1su(i,j)*heatp
                y1su(i,j)=y1su(i,j)*heatp
                z1su(i,j)=z1su(i,j)*heatp
	      end do
  510     continue

      endif
c
c     Check to see if damping should be started or terminated.
c     Criteria is that elapse should be >= tdampstrt to turn on 
c     damping and elapse should be >= tdampend to terminate it.
c     If tdampend = 0 no damping is performed.
c
c     Also turn off error checking for a while if the varibale time step
c     integrator is in use and the nose thermostat is enabled.  
c     Reduce the time step to the initial value to reduce truncation 
c     error.
c
      if(damping) then
            if(elapse.ge.tdampend) then
              damping=.false.
              write(10,59)elapse*pstimscl
              if(errtol.gt.0.0d0)then
                  rdelta=delinit/odelta
                  nerror=nstep+10
                  nerrck=nerror
               endif
            endif
         else
            if(tdampend.ne.0.and.elapse.ge.
     x        tdampstrt.and.elapse.lt.tdampend) then
              damping=.true.
              write(10,35)elapse*pstimscl
 35           format(2x,'Wall damping started at time ',f9.4)
              if(errtol.gt.0.0d0) then
                  rdelta=delinit/odelta
                  nerror=nstep+10
                  nerrck=nerror
              endif
            endif
      endif
 59   format(2x,'Wall damping terminated at time ',f9.4)
c
c     Check to see if system is equilibrated.  If tequil < 0 then system
c     is deemed equilibrated when scaling and damping are either
c     terminated or scaling has been requested to be continuous and 
c     damping is terminated.
c     If tequil >= 0 then the system is equilibrated when 
c     elapse >= tequil.
c
      if(.not.equil) then
          if((tequil.le.0.and.elapse.ge.tdampend.and.
     x      (elapse.ge.tvscal.or.tvscal.ge.ttot))
     x      .or.elapse.ge.tequil)then
              equil=.true.
              write(10,54)elapse*pstimscl
 54           format(2x,'** System equilibrated at time',f9.4,
     x       ', accumulating averages now **')
          endif
c
      endif
c
c     Print current property values to standard output device every tpr
c     picoseconds
c     pint = internal pressure
c     pintlrc = long-range internal pressure
c
      if(mod(nstep,100).eq.0) then
         write(6,470) elapse*pstimscl,hamil
	 write(6,*) 'Pressure :         ', prsscl*mpint
	 write(6,*) 'Long-range press:  ', prsscl*pintlrc
      endif

  555 format(10(1x,f8.3))
  470 format(2x,'Time = ',f12.5,' ps;',
     &' Hamiltonian = ',e12.6,' Kcal/mol')
  471 format(5(2x,f11.5))
  570 format(5(3x,f10.4))
  571 format(6(3x,f10.4))
      
	if (elapse.ge.tpr1)then
         write(10,16)elapse*pstimscl,tmpscl*trans*2.0d0/ndof,
     x                urans,potene,totene,potlrc,hamil,dense,
     x                peevee*prsscl*volscl,
     x                prsscl*mpint,
     x                epnbsum, epbasum
     >              , epblsum
     >              , eppensum,
     x                eptasum,epfixsum,enesp*enescl,epchirsum
 26   format(f11.6,1x,f7.2,1x,f6.2,1x,f9.3,1x,f9.3,1x,f9.3,1x,f9.3,
     x       1x,f6.4,1x,e10.4,1x,e11.4,1x,f8.3,1x,f8.3,3(1x,f8.3))
 16   format(f11.6,1x,f7.2,1x,f6.2,1x,f9.3,1x,f9.3,1x,f9.3,1x,f9.3,
     x       1x,f6.4,1x,e10.4,1x,e11.4,1x,f8.3,1x,f8.3,5(1x,f8.3))
c         
          if( equil ) then
              write(10,*)
              write(10,*) ' CURRENT AVERAGES, time (ps) = ',
     >                    elapse*pstimscl
              write(10,*)
              call prntiave(elapse)
C        < ---------------------- >
          end if

          tpr1=tpr1+tpr
      endif
c
c     Save all important info every nfreq timesteps just in case the
c     computer goes down in the middle of a long run.  It gets
c     put in the file runid.bak and will be overwritten each time.
c     The format is identical to that used for a restart file.
c     Also, save all the accumulated averaging information in the file
c     "runid.ave".
c
      if(condition(nstep,nfreq)) then
c
c	delete and rewrite backup files
c
        open(unit=8,file=bakfil)
        close(unit=8,status='delete')
        open(unit=8,file=avefil)
        close(unit=8,status='delete')
        CALL wrterst(bakfil)
        CALL savave(avefil)
c
c	write in trajectory file
c
	  do i=1,3
	    write(97,*) (h(i,j),j=1,3)
	  enddo
	  do i=1,nchains
	    do j=1,natmc(i)
	      write(97,971) identmc(j,i),x0mc(j,i),y0mc(j,i)
     x                      ,z0mc(j,i)
	    enddo
	   enddo
	  do i=1,nchains
	    do j=1,natsu(i)
	      write(97,971) identsu(j,i),x0su(j,i),y0su(j,i)
     x                      ,z0su(j,i)
	    enddo
	   enddo
c
c	record some useful properties
c
	  write(20,120) elapse*pstimscl,dense,avdens/estep,
     x	prsscl*mpint,prsscl*avmpint/estep,
     x	tmpscl*trans*2.0d0/ndof,tmpscl*(avekin/estep)*2.0d0/ndof
c
c	record energy components
c
	  write(30,130) elapse*pstimscl,hamil,epnbsum,epblsum,epbasum,
     x				eptasum,trans
        write(31,131) elapse*pstimscl,elasen,urans,enesp,enesp,potlrc	 
	endif

  971	format(i2,2x,3(f8.5,2x))
  120	format(f7.1,2(1x,f6.4),2(1x,f14.1),2(1x,f6.2))
  130 format(f7.1,6(1x,f9.2))
  131 format(f7.1,5(1x,f9.2))
c
      return
      end
