      subroutine prntiave(elapse)
C     
C     Calculate property running averages and standard deviations.
C     All are time-weighted estimates.
C     DNT & LRD - Fri Aug 16 20:57:34 PDT 1991
C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none

#include "ppmdparam1.h"


      integer i,j,lnblnk
      
      character*1 ffc
      
      real*8 avptcI
      real*8 herr,strsserr(3,3),mstrsserr(3,3)
      real*8 rsqerr(3),rsqslope(3),rsqint(3)
      real*8 elapse
      real*8 avhI,avrsqI(3),avavblI(3),avblerrI(3),
     x       avavbaI(4),avbaerrI(4),avstrssI(3,3),avmstrssI(3,3)
      real*8 pkeerr,wkeerr,teerr,peerr,pecerr,penerr,pelerr,peaerr,
     x       perr,mperr,picerr,ptcerr,dnserr,sperr,hamerr,peterr,
     x       avpetaI,avtoteI,avpoteI,avpeblI,avpenbI,avdensI,avpecI,
     x       avpebaI,avpintI,avmpintI,avpicI,avespI,avekinI,
     x       avewkI,avhameI,d,   avtrampI, avtramp1I

#include "averages.h"
#include "scaling.h"
#include "scalpos.h"
#include "sizes.h"
#include "steps.h"
#include "strings.h"

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if(estep.eq.0.0d0.or.nequil.le.1) then
          write(10,111)
          return
      endif
 111  format(2x,'No averaging information collected (why are you in ',
     x       'prntave.F?)')
c
c     ffc = ^L
c
      ffc=char(12)
      pkeerr=sqrt(dmax1(0.0d0,estep*avkesq-(avekin*avekin)))/estep
      pkeerr=tmpscl*pkeerr*2.0d0/ndof
      wkeerr=sqrt(dmax1(0.0d0,estep*avwksq-(avewk*avewk)))/estep
      teerr=sqrt(dmax1(0.0d0,estep*avtesq-(avtote*avtote)))
     x      /estep
      peerr=sqrt(dmax1(0.0d0,estep*avpesq-(avpote*avpote)))
     x      /estep
      pecerr=sqrt(dmax1(0.0d0,estep*avpecsq-(avpec*avpec)))
     x      /estep
      penerr=sqrt(dmax1(0.0d0,estep*avpnsq-(avpenb*avpenb)))
     x       /estep
      pelerr=sqrt(dmax1(0.0d0,estep*avplsq-(avpebl*avpebl)))
     x       /estep
      peaerr=sqrt(dmax1(0.0d0,estep*avpasq-(avpeba*avpeba)))
     x       /estep
      peterr=sqrt(dmax1(0.0d0,estep*avptsq-(avpeta*avpeta)))
     x       /estep
c      perr=prsscl*sqrt(dmax1(0.0d0,estep*avpsq-(avpint*avpint)))
c     x     /estep
      mperr=prsscl*sqrt(dmax1(0.0d0,estep*avmpsq-(avmpint*avmpint)))
     x     /estep
      picerr=prsscl*sqrt(dmax1(0.0d0,estep*avpicsq-(avpic*avpic)))
     x       /estep
      ptcerr=prsscl*sqrt(dmax1(0.0d0,estep*avptcsq-(avptc*avptc))) 
     x       /estep
      dnserr=sqrt(dmax1(0.0d0,estep*avdnsq-(avdens*avdens)))/estep
      sperr=sqrt(dmax1(0.0d0,estep*avspsq-(avesp*avesp)))/estep
      hamerr=sqrt(dmax1(0.0d0,estep*avhasq-(avhame*avhame)))
     x       /estep
      
      do 4 i=1,3
        do 3 j=1,3
          mstrsserr(i,j)=prsscl*sqrt(dmax1(0.0d0,estep*avmstrssq(i,j)-
     x                    (avmstrss(i,j)*avmstrss(i,j))))/estep
          avmstrssI(i,j)=prsscl*avmstrss(i,j)/estep
 3      continue
 4    continue

      avtoteI=avtote/estep
      avpoteI=avpote/estep
      avpecI=avpec/estep
      avpenbI=avpenb/estep
      avpeblI=avpebl/estep
      avpebaI=avpeba/estep
      avpetaI=avpeta/estep
      avmpintI=prsscl*avmpint/estep
      avpicI=prsscl*avpic/estep
      avptcI=prsscl*avptc/estep
      avdensI=avdens/estep
      avespI=avesp/estep
      avekinI=tmpscl*(avekin/estep)*2.0d0/ndof
      avewkI=avewk/estep
      avhameI=avhame/estep

      avtrampI=prsscl*avtramp/estep
      avtramp1I=prsscl*avtramp1/estep
c
      write(10,100)
      write(10,101) avekinI,avewkI,avpoteI,avtoteI,avdensI,avespI
      write(10,102) pkeerr,wkeerr,peerr,teerr,dnserr,sperr
      write(10,9991) avmpintI, mperr
9991  format(/'  PRESSURES: Running Averages (Pa) :'/
     x            '  Molecular Virial (inter.forces) : ',E16.9,
     x                ' Std.Dev. ',E16.9)

c     < ---------------------- >
      write(10,200) avpecI,avpicI,avptcI,avhameI,pecerr,picerr,ptcerr,
     x              hamerr
      write(10,103) avpenbI,avpeblI,avpebaI,avpetaI,
     x              penerr,pelerr,peaerr,peterr
      write(10,204) avmstrssI,mstrsserr
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 100  format(//,18x,'Property averages and standard deviations',//,
     x        8x,'temp.',3x,'wall k.e. ',1x,'sys. p.e.',
     x        3x,'total ene.',3x,'density',4x,'Nose s')
 101  format(2x,'Ave  ',f6.2,1x,3(f10.5,2x),f9.4,1x,f9.4)
 102  format(2x,'Sdev ',f6.2,1x,3(f10.5,2x),f9.4,1x,f9.4)
 103  format(//,13x,'Potential energy contributions (Kcal/mol)',//,8x,
     x       'non-bonded   bond length   bond angle   torsional',
     x       ' angle',/,2x,'Ave   ',f9.4,5x,f8.4,5x,f8.4,8x,f8.4,/,2x,
     x       'Sdev  ',f9.4,5x,f8.4,5x,f8.4,8x,f8.4)
 204  format(//,6x,'Average molecular stress (Pa) =',/,3(/,3d13.5),
     x       //,4x,'Std. dev. in molecular stress (Pa) =',
     x       /,3(/,3d14.6),/)
 105  format(/,14x,'Bond length (Angs)',//,
     x       '          aC-C          cC-C        C-R',/,2x,
     x       'Ave  ',3(f10.7,3x),/,2x,'Sdev ',3(f10.7,3x),//)
 106  format(/,14x,'Bond angle (Degs)',//,
     x       10x,' rcc     c-ccc      a-ccc      rcr',/,2x,
     x       'Ave  ',4(f8.3,2x),/,2x,'Sdev ',4(f8.4,2x))
 107  format(/,3(2x,'Group ',i1,4x,'(',a,')',/,2x,
     x         'Mean (not total) square distance',/,2x,
     x         'Ave   =',f10.5,' A^2',/,2x,'Sdev  =',f10.5,/,2x,
     x         'Slope =',d11.4,10x,'Intercept =',d11.4,//))
 108  format(a1,/,2x,'Average cell dimensions (Angs) =   ',f10.5)
 109  format(/,4x,'Std. dev. cell dimensions =   ',f11.6)
 200  format(//,8x,'Long-range contributions',19x,'Other',//,9x,
     x       'Sys. P.E.      Int. Prssr.',6x,'Tot. Prssr.',7x,'Hamil.',
     x       /,2x,'Ave   ',f10.5,2(4x,d13.5),4x,f10.5,
     x       /,2x,'Sdev  ',f10.5,2(4x,d13.5),4x,f10.5)
c     < ---------------------- >
c
      return
      end
