
      subroutine readold(oldfil)
c
c  Read in old information to continue a run.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      
      implicit none

#include "ppmdparam1.h"

      integer i,j,k,lnblnk,n
      character*(*) oldfil

      real*8 sumv2,xij1,yij1,zij1,heater
c     real*8 del1,del2,del3,del4,del5

#include "box.h"
#include "box2.h"
#include "conv.h"
#include "derivs.h"
#include "initial.h"
#include "paramsr.h"
#include "scaling.h"
#include "scalpos.h"
#include "shape.h"
#include "sizes.h"
#include "switches.h"
#include "times.h"
#include "which.h"

c #include "pentrnt.h"
	
	external lnblnk

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      open(unit=8,file=oldfil,status='old')
c     
	  n = 0
	  Read(8,*) nchains, nspec(0)
c
c	  Check for dimensioning errors
c
        if(nchains.gt.maxchain) then
          write(10,10)
          write(10,*)'     requested ',nchains,' chains'
          stop 'readnew: # of chains dimensioning error'
        endif

	  Do i=1,nspec(0)
		Read(8,*) nspec(i), McNat(i), SuNat(i)
		Do j=1,nspec(i)
			n=n+1
			Natmc(n)=McNat(i)
			Natsu(n)=SuNat(i)
			natoms(n)=natmc(n)+natsu(n)
			nun(n)=natsu(n)/2
c
c		Check for dimensioning errors
c
		if(natoms(i).gt.maxatms) then
            write(10,15)
            write(10,*)'     requested ', natoms(i),' atoms'
            write(10,*)'    (requested ', nun(i),' repeat units)'
            stop 'readnew: # of atoms dimensioning error'
		endif

		End Do
	  Enddo
	  n = 0
	read(8,*) elapse

   10 format(/,2x,'*** Number of chains dimensioning error ***')
   15 format(/,2x,'*** Number of atoms dimensioning error ***')

      if(nchains.eq.0) then
         write(10,20)
         stop 'readold: reading # of chains error'
      endif

   20 format(2x,'Reading number of chains error')

      do j=1,nchains
	  do i=1,natmc(j)
          read (8,*) identmc(i,j), x0mc(i,j), y0mc(i,j), z0mc(i,j)
          read (8,*) x1mc(i,j), y1mc(i,j), z1mc(i,j)
          read (8,*) x2mc(i,j), y2mc(i,j), z2mc(i,j)
          read (8,*) x3mc(i,j), y3mc(i,j), z3mc(i,j)
          read (8,*) x4mc(i,j), y4mc(i,j), z4mc(i,j)
          read (8,*) x5mc(i,j), y5mc(i,j), z5mc(i,j)
	  end do
	  do i=1,natsu(j)
          read (8,*) identsu(i,j), x0su(i,j), y0su(i,j), z0su(i,j)
          read (8,*) x1su(i,j), y1su(i,j), z1su(i,j)
          read (8,*) x2su(i,j), y2su(i,j), z2su(i,j)
          read (8,*) x3su(i,j), y3su(i,j), z3su(i,j)
          read (8,*) x4su(i,j), y4su(i,j), z4su(i,j)
          read (8,*) x5su(i,j), y5su(i,j), z5su(i,j)
	  end do
	end do
         
c
      do j=1,3
	 read(8,*) (h(i,j),i=1,3)
      enddo

      do j=1,3
         read(8,*) (g(i,j),i=1,3)
      enddo

      read(8,*) vol
      read(8,*) sp0,sp1,sp2
	read(8,*) sp3,sp4,sp5
      read(8,*) hl0,hl1,hl2
	read(8,*) hl3,hl4,hl5
c
      close(unit=8)
c      call wrtconf
c      stop
c
c     Set number of system degrees of freedom
c
	ndof = 0
      if(constraint) then
	  Do i = 1,nchains
	    ndof = ndof + natoms(i)+natoms(i)+1
	  End Do
      else
	  Do i = 1,nchains
	    ndof = ndof + natoms(i)+natoms(i)+natoms(i)
	  End Do
      endif

      if(nose) then
            ndof=ndof+3
      endif
c
c      if(constraint) then
c            ndof=(2*natoms+1)*nchains - 3 ! WHY MINUS THREE ?? !!
c         else
c           ndof=3*natoms*nchains
c      endif
c      if(nose) then
c            ndof=ndof+3
c      endif
c
c
c     If using velocity rescaling to control temperature, rescale the
c     particle velocities to give the run temperature.
c     Skip if using Nose control.
c     You need to convert to real coordinates to calculate proper ke,
c     then convert back to internal coordinates after re-scaling.
c
      call matinv(h,hi,vol)
      if(.not.nose) then
        WRITE(*,*)' readold: WARNING!'
        WRITE(*,*)'     initial polymer velocities being rescaled'
          sumv2=0.0d0
          do 128 j=1,nchains
             do i=1,natmc(j)
                sumv2=(x1mc(i,j)*x1mc(i,j)+y1mc(i,j)*y1mc(i,j)+
     x			     z1mc(i,j)*z1mc(i,j))
     x                 *umass(identmc(i,j))+sumv2
	       end do
          do i=1,natsu(j)
                sumv2=(x1su(i,j)*x1su(i,j)+y1su(i,j)*y1su(i,j)+
     x      			 z1su(i,j)*z1su(i,j))
     x                 *umass(identsu(i,j))+sumv2
	       end do
 128      continue
          heater=sqrt(dfloat(ndof)*tstar/sumv2)
          do 126 j=1,nchains
             do i=1,natmc(j)
                xij1=x1mc(i,j)*heater
                yij1=y1mc(i,j)*heater
                zij1=z1mc(i,j)*heater
                x1mc(i,j)=hi(1,1)*xij1+hi(1,2)*yij1+hi(1,3)*zij1
                y1mc(i,j)=hi(2,1)*xij1+hi(2,2)*yij1+hi(2,3)*zij1
                z1mc(i,j)=hi(3,1)*xij1+hi(3,2)*yij1+hi(3,3)*zij1
	         end do
             do i=1,natsu(j)
                xij1=x1su(i,j)*heater
                yij1=y1su(i,j)*heater
                zij1=z1su(i,j)*heater
                x1su(i,j)=hi(1,1)*xij1+hi(1,2)*yij1+hi(1,3)*zij1
                y1su(i,j)=hi(2,1)*xij1+hi(2,2)*yij1+hi(2,3)*zij1
                z1su(i,j)=hi(3,1)*xij1+hi(3,2)*yij1+hi(3,3)*zij1
	         end do
 126      continue
          
      endif
c
c     Put time step info into the predictor taylor series components
c

      do 130 j=1,nchains
         do i=1,natmc(j)
            x1mc(i,j)=x1mc(i,j)*delta
            y1mc(i,j)=y1mc(i,j)*delta
            z1mc(i,j)=z1mc(i,j)*delta
            x2mc(i,j)=x2mc(i,j)*delsq
            y2mc(i,j)=y2mc(i,j)*delsq
            z2mc(i,j)=z2mc(i,j)*delsq
            x3mc(i,j)=x3mc(i,j)*delcu
            y3mc(i,j)=y3mc(i,j)*delcu
            z3mc(i,j)=z3mc(i,j)*delcu
            x4mc(i,j)=x4mc(i,j)*delqu
            y4mc(i,j)=y4mc(i,j)*delqu
            z4mc(i,j)=z4mc(i,j)*delqu
            x5mc(i,j)=x5mc(i,j)*delqt
            y5mc(i,j)=y5mc(i,j)*delqt
            z5mc(i,j)=z5mc(i,j)*delqt
	     end do 
         do i=1,natsu(j)
            x1su(i,j)=x1su(i,j)*delta
            y1su(i,j)=y1su(i,j)*delta
            z1su(i,j)=z1su(i,j)*delta
            x2su(i,j)=x2su(i,j)*delsq
            y2su(i,j)=y2su(i,j)*delsq
            z2su(i,j)=z2su(i,j)*delsq
            x3su(i,j)=x3su(i,j)*delcu
            y3su(i,j)=y3su(i,j)*delcu
            z3su(i,j)=z3su(i,j)*delcu
            x4su(i,j)=x4su(i,j)*delqu
            y4su(i,j)=y4su(i,j)*delqu
            z4su(i,j)=z4su(i,j)*delqu
            x5su(i,j)=x5su(i,j)*delqt
            y5su(i,j)=y5su(i,j)*delqt
            z5su(i,j)=z5su(i,j)*delqt
	    end do
  130 continue

      sp1=sp1*delta
      sp2=sp2*delsq
      sp3=sp3*delcu
      sp4=sp4*delqu
      sp5=sp5*delqt
 
      if(.not.move) then
         hl1=0.0d0
         hl2=0.0d0
         hl3=0.0d0
         hl4=0.0d0
         hl5=0.0d0
 
         do 155 i=1,3
           do 155 j=1,3
             hinit(j,i)=h(j,i)
  155    continue
      else
         if(uniform) then
           hl1=hl1*delta
           hl2=hl2*delsq
           hl3=hl3*delcu
           hl4=hl4*delqu
           hl5=hl5*delqt
c
c          Set the box shape tensor.  If the dilation factor
c          velocity and force from the last run are zero, then
c          the last run was not under uniform dilation and the
c          box is frozen with the shape it had at the end
c          of the last run.  If the velocity or force are
c          non-zero, then this is a continuation of a uniform
c          dilation run, and the shape tensor is set to the
c          value from the last run.
c
c          if(hl1.ne.0.0d0.or.hl2.ne.0.0d0) then
           do 160 i=1,3
             do 160 j=1,3
                hinit(j,i)=h(j,i)/hl0
  160      continue
 
         endif
      endif

      return
      end
