
      subroutine verlet
c
c  Create verlet neighbor tables
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none 

#include "ppmdparam1.h"
#include "ppmdparam2.h"
c#include "pentrnt.h"

      integer npair,idatom1,idatom2
      integer nc,nci,ncj,i,ip1,nll,j,
     x        n1,n2,nx,ny,nz,k
c    x       ,ii,jj,kk,ll,jm3

      logical inlist(maxatms)
      real*8 nt(maxatms),rsq1,x,y,z

#include "box.h"
#include "listi.h"
c#include "listpen.h"
#include "listr.h"
#include "posit.h"
#include "potprm.h"
#include "scalpos.h"
#include "scaling.h"
#include "sizes.h"
#include "times.h"
#include "which.h"
c	integer mistbli(maxbonds),mistblj(maxbonds)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
        do nci = 1,nchains

	  do i = 1,natmc(nci)
		      
          x = x0mc(i,nci)
          y = y0mc(i,nci)
          z = z0mc(i,nci)
C
	  nx = x + x
          x0mc(i,nci) = x - nx
	  ny = y + y
          y0mc(i,nci) = y - ny
          nz = z + z
          z0mc(i,nci) = z - nz
										
          enddo

        do i = 1,natsu(nci)
		      
          x = x0su(i,nci)
          y = y0su(i,nci)
          z = z0su(i,nci)
C
	  nx = x + x
          x0su(i,nci) = x - nx
	  ny = y + y
          y0su(i,nci) = y - ny
          nz = z + z
          z0su(i,nci) = z - nz
										
          enddo
       enddo
c	
c     Construct non-bonded neighbor list. Atoms less than three bonds
c     apart are excluded from the list because they dont have non-bonded interactions
c
      nll=0

c     Orthogonal simulation cell -- use fast method for getting
c     minimum image.
c
      do 56 nci=1,nchains
         do 55 ncj=nci,nchains

c     Theoroume ta atoma mc na briskontai eite sthn idia eite se diaforetikes alysides
c           
		  do 54 i=1,natmc(nci)
c
c              marker(i,nci,ncj)+1 is for atom i on chain nci,
c              interacting with chain ncj
c
               markermcmc(i,nci,ncj)=nll
c		write(17,*) 'mcmc',nci,ncj,i,nll
c              write(10,*) 'Marker = ',i,nci,ncj,marker(i,nci,ncj)
               
			 idatom1=identmc(i,nci)

c
               ip1 = i+3


c              Find minimum image pair for atoms i and j, decide
c              if they are in neighbor list for each other, save
c              result in logtmp. This looks a little strange and 
c              more calculations are done than absolutely needed,
c              but it is actually faster because allows a more
c              effiecient vectorization/parallelization to be 
c              carried out.
c
               if(nci.ne.ncj) ip1=1
               
	       do 51 j=ip1,natmc(ncj)

                  idatom2=identmc(j,ncj)
                  x=x0mc(i,nci)-x0mc(j,ncj)
                  nx=x+x
                  x=x-nx
                  y=y0mc(i,nci)-y0mc(j,ncj)
                  ny=y+y
                  y=y-ny
                  z=z0mc(i,nci)-z0mc(j,ncj)
                  nz=z+z
                  z=z-nz
                  rsq1=x*h(1,1)*h(1,1)*x+y*h(2,2)*h(2,2)*y+
     x                 z*h(3,3)*h(3,3)*z
c
c                 Construct neighbor list table

                  if (rsq1.le.sansq(idatom1,idatom2)) then
                       nll=nll+1
                      listnb(nll)=j
                   endif

  51           continue

  54         continue

        	  markermcmc(natmc(nci)+1,nci,ncj)=nll
c		write(17,*) 'mcmc',nci,ncj,natmc+1,nll

c     Ta atoma su briskontai eite sthn idia eite se diaforetikes alysides
        
	  do i=1,natsu(nci)
          markersusu(i,nci,ncj)=nll
c		write(300,*) 'susu',nci,ncj,i,nll
           idatom1=identsu(i,nci)
         ip1 = sutmc(i) 
            do j=ip1+1,natmc(ncj)-1 
               k = mctsu(j) 
               if(k .ne. 0) goto 111 
            enddo 
            if(k .eq. 0) ip1 = natsu(ncj)+1 

111         if(k.gt.1) ip1 = k-1 
           

c	  if(mod(i,2).eq.0.and.i.ne.1) then 
	  
c	  ip1=i+1

c	 else

c	  ip1 = i +2

c	 endif

c           write(300,*) i,ip1  
		   
		 if(nci.ne.ncj) ip1=1
               
	       do j=ip1,natsu(ncj),1
               idatom2=identsu(j,ncj)
                  x=x0su(i,nci)-x0su(j,ncj)
                  nx=x+x
                  x=x-nx
                  y=y0su(i,nci)-y0su(j,ncj)
                  ny=y+y
                  y=y-ny
                  z=z0su(i,nci)-z0su(j,ncj)
                  nz=z+z
                  z=z-nz
                  rsq1=x*h(1,1)*h(1,1)*x+y*h(2,2)*h(2,2)*y+
     x                 z*h(3,3)*h(3,3)*z
c
              if (rsq1.le.sansq(idatom1,idatom2)) then
                      nll=nll+1
                      listnb(nll)=j
              endif

	  enddo

	  enddo

        	  markersusu(natsu(nci)+1,nci,ncj)=nll
c		write(200,*) 'susu',nci,ncj,natsu+1,nll


   55   continue
   56   continue

c     Ta atoma mc kai su briskontai eite sthn idia eite se diaforetikes alysides
   
          do nci=1,nchains
	    do ncj=1,nchains

            do i=1,natmc(nci)

          markermcsu(i,nci,ncj)=nll
           idatom1=identmc(i,nci)
                
	       do j=1,natsu(ncj)

               idatom2=identsu(j,ncj)

             x=x0mc(i,nci)-x0su(j,ncj)
             nx=x+x
             x=x-nx
             y=y0mc(i,nci)-y0su(j,ncj)
             ny=y+y
             y=y-ny
             z=z0mc(i,nci)-z0su(j,ncj)
             nz=z+z
             z=z-nz
             rsq1=x*h(1,1)*h(1,1)*x+y*h(2,2)*h(2,2)*y+
     x            z*h(3,3)*h(3,3)*z

	    k=iabs(i-sutmc(j))
c
              if((rsq1.le.sansq(idatom1,idatom2)).and.
     x            ((k.ge.2).or.(nci.ne.ncj))) then
                      nll=nll+1
                     listnb(nll)=j
              endif
	  enddo

                                  
       	   enddo

	    markermcsu(natmc(nci)+1,nci,ncj)=nll

        enddo
	enddo
            

c
c      mibl no longer in use 1/8/96
c      Bond length minimum image
c

c     Save the real space atom positions to allow calculation of the
c     displacements for the next update test.
c
      do 100 nc=1,nchains
         do i=1,natmc(nc)
            xstmc(i,nc)=rxmc(i,nc)
            ystmc(i,nc)=rymc(i,nc)
            zstmc(i,nc)=rzmc(i,nc)
	  enddo

         do i=1,natsu(nc)
            xstsu(i,nc)=rxsu(i,nc)
            ystsu(i,nc)=rysu(i,nc)
            zstsu(i,nc)=rzsu(i,nc)
	  enddo

  100 continue
      do 110 i=1,3
         do 110 j=1,3
         hst(j,i)=h(j,i)
  110 continue
c
c     Count the number of times the list was updated for informational
c     purposes
c
      kount=kount+1

      return
      end
c
c	Basika, n movn ousiastikh allagh edw eivai o opismos twv n1, n2
c	se suvduasmo me tov opismo tns next neighbour list (nnblst) stnv
c	initialize.F. Oi pio polles allages sxetika me tnv Verlet list
c	givovtai stn nonbond.F para edw
c
