
      subroutine wrterst(filnam)
c 
c  Write out information that can be used to restart a simulation.
c  This is not done in the most elegant way, but it does allow one
c  to read in old single-chain data.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      implicit none

#include "ppmdparam1.h"

      integer i,j,k
      character*(*) filnam

#include "box.h"
#include "box2.h"
#include "conv.h"
#include "derivs.h"
#include "scalpos.h"
#include "sizes.h"
#include "times.h"
#include "which.h"

c #include "pentrnt.h"

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      open(unit=8,file=filnam,status='unknown')
c
c     All higher derivative quantities must be time de-scaled
c     x0/x1/x2/... were written out in molecular units times
c     (boxlength/sigmaHH)
c     x0/x1/x2/... are written out in units of boxlength
c
      write(8,*) nchains, nspec(0)
c
c	Do i=1,nchains
c	  write(8,*) nun(i),natmc(i),natsu(i)
c	  write(8,*) natmc(i),natsu(i)
c	End do
c
	Do i=1,nspec(0)
	  write(8,*) nspec(i), McNat(i), SuNat(i)
 	End Do

	write(8,*) elapse

      do j=1,nchains
	do i=1,natmc(j)
         write(8,99) identmc(i,j), x0mc(i,j), y0mc(i,j), z0mc(i,j)
         write(8,100) x1mc(i,j)/delta, y1mc(i,j)/delta, z1mc(i,j)/delta
         write(8,100) x2mc(i,j)/delsq, y2mc(i,j)/delsq, z2mc(i,j)/delsq
         write(8,100) x3mc(i,j)/delcu, y3mc(i,j)/delcu, z3mc(i,j)/delcu
         write(8,100) x4mc(i,j)/delqu, y4mc(i,j)/delqu, z4mc(i,j)/delqu
         write(8,100) x5mc(i,j)/delqt, y5mc(i,j)/delqt, z5mc(i,j)/delqt
	end do
	do i=1,natsu(j)
         write(8,99) identsu(i,j), x0su(i,j), y0su(i,j), z0su(i,j)
         write(8,100) x1su(i,j)/delta, y1su(i,j)/delta, z1su(i,j)/delta
         write(8,100) x2su(i,j)/delsq, y2su(i,j)/delsq, z2su(i,j)/delsq
         write(8,100) x3su(i,j)/delcu, y3su(i,j)/delcu, z3su(i,j)/delcu
         write(8,100) x4su(i,j)/delqu, y4su(i,j)/delqu, z4su(i,j)/delqu
         write(8,100) x5su(i,j)/delqt, y5su(i,j)/delqt, z5su(i,j)/delqt
	 end do
	end do
c
      do j=1,3
         write(8,*) (h(i,j),i=1,3)
      enddo

      do j=1,3
         write(8,*) (g(i,j),i=1,3)
      enddo


      write(8,*) vol

      write(8,100) sp0,sp1/delta,sp2/delsq
      write(8,100) sp3/delcu,sp4/delqu,sp5/delqt
      write(8,100) hl0,hl1/delta,hl2/delsq
      write(8,100) hl3/delcu,hl4/delqu,hl5/delqt
c
c
99    format(i1,2x,3(f20.8,3x))
100   format(3(3x,f20.8))
101   format(6(2x,f20.8))

      close(unit=8)
      return
      end
